/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "../array.h"

#ifndef LIBCDSB_EXTRA_ARRAY_H
#define LIBCDSB_EXTRA_ARRAY_H

#ifdef array_find
#  undef array_find
#endif
#ifdef array_push
#  undef array_push
#endif

extern ssize_t array_find(const vtype_array* x, const void* value, vtype value_type);
extern ssize_t array_push(      vtype_array* x, const void* value, vtype value_type);

#endif /* LIBCDSB_EXTRA_ARRAY_H */
