/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "include.h"

void string_replace(str_t* x, char* p, size_t n, const char* v, size_t vn) {
    if (n != vn) {
        size_t l = strlen(x->buffer);

        if (n < vn) {
            char* t = x->buffer;

            x->buffer = realloc(x->buffer, l + (vn - n) + 1);
            p = x->buffer + (p - t);
        }

        memmove(p+vn, p+n, l - (p+n - x->buffer) + 1);
    }

    memcpy(p, v, vn);
}
