/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "plug.h"

int main(int argc, char** argv) {
    test_init(argc, argv);

    vtype_array y;
    vtype_array x = array_random(8);

    array_info(&x);
    array_sort(&x);
    array_print(&x, 0);

    array_slice(&y, &x, 2, 4, 1);

    array_print(&x, "source");
    array_print(&y, "cutted");

    array_remove_by_index(&x, -1);
    array_remove_by_index(&y, -1);

    array_print(&x, "source (last removed)");
    array_print(&y, "cutted (last removed)");

    array_free(&x);
    array_free(&y);
}
